Public Class formEdit
    Inherits System.Windows.Forms.Form
    'Public ItemPath As String

    Public Sub setItemPath(ByVal rItemPath As String)
        Dim reply As New ReplyBase
        Dim rOpt As New RequestOptions
        Dim items As New ReadRequestItemList
        Dim ritems As ReplyItemList
        Dim errors As OPCError()

        txtItemName.Text = rItemPath

        rOpt.ReturnErrorText = True
        rOpt.ReturnItemTime = True
        rOpt.ClientRequestHandle = getClientHandle()
        rOpt.LocaleID = LocaleID
        'items.MaxAge = 0     '0 significa "leggilo dal device"
        items.MaxAgeSpecified = False
        ReDim items.Items(0)
        items.Items(0) = New ReadRequestItem
        items.Items(0).ItemName = rItemPath
        Try
            reply = Srv.Read(rOpt, items, ritems, errors)

            For Each err As OPCError In errors
                formMainI.addToLog(err.ID.Name + "    " + err.Text)
            Next

            For Each ri As ItemValue In ritems.Items  'dovrebbe contenere 1 elemento
                cbLimitField.SelectedIndex = ri.Quality.LimitField
                cbQualityField.SelectedIndex = ri.Quality.QualityField
                txtVendorField.Text = isntNothing(ri.Quality.VendorField)
                txtTimestamp.Text = ri.Timestamp
                txtValue.Text = ri.Value
                cbValueTypeQualifier.Text = isntNothing(ri.ValueTypeQualifier)
            Next
        Catch err As Exception
            formMainI.addToLog(err.Message)
        End Try
    End Sub


#Region " Codice generato da Progettazione Windows Form "

    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'Form esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    Friend WithEvents buttOk As System.Windows.Forms.Button
    Friend WithEvents txtValue As System.Windows.Forms.TextBox
    Friend WithEvents txtTimestamp As System.Windows.Forms.TextBox
    Friend WithEvents cbLimitField As System.Windows.Forms.ComboBox
    Friend WithEvents cbQualityField As System.Windows.Forms.ComboBox
    Friend WithEvents txtVendorField As System.Windows.Forms.TextBox
    Friend WithEvents txtItemName As System.Windows.Forms.TextBox
    Friend WithEvents Label0 As System.Windows.Forms.Label
    Friend WithEvents buttAnnulla As System.Windows.Forms.Button
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents cbValueTypeQualifier As System.Windows.Forms.ComboBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.buttOk = New System.Windows.Forms.Button
        Me.txtValue = New System.Windows.Forms.TextBox
        Me.txtTimestamp = New System.Windows.Forms.TextBox
        Me.cbLimitField = New System.Windows.Forms.ComboBox
        Me.cbQualityField = New System.Windows.Forms.ComboBox
        Me.txtVendorField = New System.Windows.Forms.TextBox
        Me.txtItemName = New System.Windows.Forms.TextBox
        Me.Label0 = New System.Windows.Forms.Label
        Me.buttAnnulla = New System.Windows.Forms.Button
        Me.Label10 = New System.Windows.Forms.Label
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label12 = New System.Windows.Forms.Label
        Me.Label13 = New System.Windows.Forms.Label
        Me.Label14 = New System.Windows.Forms.Label
        Me.Label15 = New System.Windows.Forms.Label
        Me.cbValueTypeQualifier = New System.Windows.Forms.ComboBox
        Me.SuspendLayout()
        '
        'buttOk
        '
        Me.buttOk.Location = New System.Drawing.Point(336, 16)
        Me.buttOk.Name = "buttOk"
        Me.buttOk.Size = New System.Drawing.Size(88, 40)
        Me.buttOk.TabIndex = 30
        Me.buttOk.Text = "Ok"
        '
        'txtValue
        '
        Me.txtValue.Location = New System.Drawing.Point(136, 37)
        Me.txtValue.Name = "txtValue"
        Me.txtValue.Size = New System.Drawing.Size(176, 20)
        Me.txtValue.TabIndex = 19
        Me.txtValue.Text = ""
        '
        'txtTimestamp
        '
        Me.txtTimestamp.Location = New System.Drawing.Point(136, 145)
        Me.txtTimestamp.Name = "txtTimestamp"
        Me.txtTimestamp.Size = New System.Drawing.Size(176, 20)
        Me.txtTimestamp.TabIndex = 29
        Me.txtTimestamp.Text = ""
        '
        'cbLimitField
        '
        Me.cbLimitField.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbLimitField.Items.AddRange(New Object() {"none", "low", "high", "constant"})
        Me.cbLimitField.Location = New System.Drawing.Point(136, 80)
        Me.cbLimitField.Name = "cbLimitField"
        Me.cbLimitField.Size = New System.Drawing.Size(176, 21)
        Me.cbLimitField.TabIndex = 23
        '
        'cbQualityField
        '
        Me.cbQualityField.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbQualityField.Items.AddRange(New Object() {"bad", "badConfigurationError", "badNotConnected", "badDeviceFailure", "badSensorFailure", "badLastKnownValue", "badCommFailure", "badOutOfService", "badWaitingForInitialData", "uncertain", "uncertainLastUsableValue", "uncertainSensorNotAccurate", "uncertainEUExceeded", "uncertainSubNormal", "good"})
        Me.cbQualityField.Location = New System.Drawing.Point(136, 102)
        Me.cbQualityField.Name = "cbQualityField"
        Me.cbQualityField.Size = New System.Drawing.Size(176, 21)
        Me.cbQualityField.TabIndex = 25
        '
        'txtVendorField
        '
        Me.txtVendorField.Location = New System.Drawing.Point(136, 124)
        Me.txtVendorField.Name = "txtVendorField"
        Me.txtVendorField.Size = New System.Drawing.Size(176, 20)
        Me.txtVendorField.TabIndex = 27
        Me.txtVendorField.Text = ""
        '
        'txtItemName
        '
        Me.txtItemName.Location = New System.Drawing.Point(136, 16)
        Me.txtItemName.Name = "txtItemName"
        Me.txtItemName.Size = New System.Drawing.Size(176, 20)
        Me.txtItemName.TabIndex = 17
        Me.txtItemName.Text = ""
        '
        'Label0
        '
        Me.Label0.Location = New System.Drawing.Point(32, 16)
        Me.Label0.Name = "Label0"
        Me.Label0.Size = New System.Drawing.Size(104, 16)
        Me.Label0.TabIndex = 16
        Me.Label0.Text = "&Item"
        '
        'buttAnnulla
        '
        Me.buttAnnulla.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.buttAnnulla.Location = New System.Drawing.Point(336, 64)
        Me.buttAnnulla.Name = "buttAnnulla"
        Me.buttAnnulla.Size = New System.Drawing.Size(88, 40)
        Me.buttAnnulla.TabIndex = 31
        Me.buttAnnulla.Text = "Annulla"
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(32, 126)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(104, 16)
        Me.Label10.TabIndex = 26
        Me.Label10.Text = "V&endorField"
        '
        'Label11
        '
        Me.Label11.Location = New System.Drawing.Point(32, 104)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(104, 16)
        Me.Label11.TabIndex = 24
        Me.Label11.Text = "&QualityField"
        '
        'Label12
        '
        Me.Label12.Location = New System.Drawing.Point(32, 148)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(104, 16)
        Me.Label12.TabIndex = 28
        Me.Label12.Text = "&Timestamp"
        '
        'Label13
        '
        Me.Label13.Location = New System.Drawing.Point(32, 82)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(104, 16)
        Me.Label13.TabIndex = 22
        Me.Label13.Text = "&LimitField"
        '
        'Label14
        '
        Me.Label14.Location = New System.Drawing.Point(32, 38)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(104, 16)
        Me.Label14.TabIndex = 18
        Me.Label14.Text = "&Value"
        '
        'Label15
        '
        Me.Label15.Location = New System.Drawing.Point(32, 60)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(104, 16)
        Me.Label15.TabIndex = 20
        Me.Label15.Text = "ValueT&ypeQualifier:"
        '
        'cbValueTypeQualifier
        '
        Me.cbValueTypeQualifier.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbValueTypeQualifier.Items.AddRange(New Object() {"", "time", "date", "duration"})
        Me.cbValueTypeQualifier.Location = New System.Drawing.Point(136, 58)
        Me.cbValueTypeQualifier.Name = "cbValueTypeQualifier"
        Me.cbValueTypeQualifier.Size = New System.Drawing.Size(176, 21)
        Me.cbValueTypeQualifier.TabIndex = 21
        '
        'formEdit
        '
        Me.AcceptButton = Me.buttOk
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.buttAnnulla
        Me.ClientSize = New System.Drawing.Size(442, 183)
        Me.Controls.Add(Me.cbValueTypeQualifier)
        Me.Controls.Add(Me.Label10)
        Me.Controls.Add(Me.Label11)
        Me.Controls.Add(Me.Label12)
        Me.Controls.Add(Me.Label13)
        Me.Controls.Add(Me.Label14)
        Me.Controls.Add(Me.Label15)
        Me.Controls.Add(Me.buttAnnulla)
        Me.Controls.Add(Me.txtItemName)
        Me.Controls.Add(Me.Label0)
        Me.Controls.Add(Me.txtVendorField)
        Me.Controls.Add(Me.cbQualityField)
        Me.Controls.Add(Me.cbLimitField)
        Me.Controls.Add(Me.txtTimestamp)
        Me.Controls.Add(Me.txtValue)
        Me.Controls.Add(Me.buttOk)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "formEdit"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Modifica item"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub buttOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttOk.Click
        Dim reply As New ReplyBase
        Dim rOpt As New RequestOptions
        Dim items As New WriteRequestItemList
        Dim ritems As ReplyItemList
        Dim errors As OPCError()

        ReDim items.Items(0)
        items.Items(0) = New ItemValue

        Try
            With items.Items(0)
                If cbValueTypeQualifier.Text <> "" Then .ValueTypeQualifier = New System.Xml.XmlQualifiedName(cbValueTypeQualifier.Text) '***?
                .ItemName = txtItemName.Text
                .Quality = New OPCQuality
                .Quality.LimitField = cbLimitField.SelectedIndex
                .Quality.QualityField = cbQualityField.SelectedIndex
                If txtVendorField.Text <> "" Then
                    Dim v As Integer = Int(txtVendorField.Text)
                    If v >= 0 And v < 256 Then .Quality.VendorField = v
                End If
                copyIfcond(.Timestamp, txtTimestamp.Text, .TimestampSpecified)
                .Value = txtValue.Text
            End With
        Catch err As Exception
            MsgBox(err.Message)
            Exit Sub
        End Try

        rOpt.ReturnErrorText = True
        'rOpt.ReturnItemTime = True
        rOpt.ClientRequestHandle = getClientHandle()
        rOpt.LocaleID = LocaleID
        Try
            reply = Srv.Write(rOpt, items, False, ritems, errors)

            For Each err As OPCError In errors
                formMainI.addToLog(err.ID.Name + "    " + err.Text)
            Next
        Catch err As Exception
            MsgBox(err.Message)
            Exit Sub
        End Try
        Close()
    End Sub

    Private Sub buttAnnulla_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttAnnulla.Click
        Close()
    End Sub


    Private Sub txtVendorField_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtVendorField.LostFocus
        tb2Integer(txtVendorField, "")
        If txtVendorField.Text <> "" Then
            If (txtVendorField.Text < 0 Or txtVendorField.Text > 255) Then txtVendorField.Text = ""
        End If
    End Sub

    Private Sub txtTimestamp_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtTimestamp.LostFocus
        tb2Date(txtTimestamp, "")
    End Sub
End Class
