Public Class formRead
    Inherits System.Windows.Forms.Form

#Region " Codice generato da Progettazione Windows Form "

    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'Form esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents buttRead As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtMaxAge As System.Windows.Forms.TextBox
    Friend WithEvents GItemList1 As opc_xml_da_client.gItemList
    Friend WithEvents buttClose As System.Windows.Forms.Button
    Friend WithEvents Button1 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(formRead))
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.Button1 = New System.Windows.Forms.Button
        Me.buttClose = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtMaxAge = New System.Windows.Forms.TextBox
        Me.buttRead = New System.Windows.Forms.Button
        Me.GItemList1 = New opc_xml_da_client.gItemList
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.Button1)
        Me.Panel1.Controls.Add(Me.buttClose)
        Me.Panel1.Controls.Add(Me.Label1)
        Me.Panel1.Controls.Add(Me.txtMaxAge)
        Me.Panel1.Controls.Add(Me.buttRead)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Top
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(696, 48)
        Me.Panel1.TabIndex = 2
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(368, 8)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(112, 32)
        Me.Button1.TabIndex = 4
        Me.Button1.Text = "&<<"
        '
        'buttClose
        '
        Me.buttClose.Location = New System.Drawing.Point(480, 8)
        Me.buttClose.Name = "buttClose"
        Me.buttClose.Size = New System.Drawing.Size(112, 32)
        Me.buttClose.TabIndex = 5
        Me.buttClose.Text = "Chiudi"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(96, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "&MaxAge (ms):"
        '
        'txtMaxAge
        '
        Me.txtMaxAge.Location = New System.Drawing.Point(112, 16)
        Me.txtMaxAge.Name = "txtMaxAge"
        Me.txtMaxAge.Size = New System.Drawing.Size(128, 20)
        Me.txtMaxAge.TabIndex = 2
        Me.txtMaxAge.Text = "1000"
        '
        'buttRead
        '
        Me.buttRead.Location = New System.Drawing.Point(256, 8)
        Me.buttRead.Name = "buttRead"
        Me.buttRead.Size = New System.Drawing.Size(112, 32)
        Me.buttRead.TabIndex = 3
        Me.buttRead.Text = "&Read"
        '
        'GItemList1
        '
        Me.GItemList1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.GItemList1.ItemsReadOnly = True
        Me.GItemList1.ListReadOnly = False
        Me.GItemList1.Location = New System.Drawing.Point(0, 48)
        Me.GItemList1.Name = "GItemList1"
        Me.GItemList1.Size = New System.Drawing.Size(696, 269)
        Me.GItemList1.SubscriptionList = False
        Me.GItemList1.TabIndex = 0
        Me.GItemList1.VeryReadOnly = False
        '
        'formRead
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(696, 317)
        Me.Controls.Add(Me.GItemList1)
        Me.Controls.Add(Me.Panel1)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "formRead"
        Me.Text = "Read list"
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub buttRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttRead.Click
        If GItemList1.lvItems.Items.Count = 0 Then
            MsgBox("Deve essere presente almeno un elemento nella lista", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        Dim reply As New ReplyBase
        Dim rOpt As New RequestOptions
        Dim items As New ReadRequestItemList
        Dim ritems As ReplyItemList
        Dim errors As OPCError()

        rOpt.ReturnErrorText = True
        rOpt.ReturnItemTime = True
        rOpt.ClientRequestHandle = getClientHandle()
        rOpt.LocaleID = LocaleID
        If txtMaxAge.Text = "" Then
            items.MaxAgeSpecified = False
        Else '(se la casella di testo non  vuota)
            items.MaxAge = CInt(txtMaxAge.Text)
            items.MaxAgeSpecified = True
        End If
        ReDim items.Items(GItemList1.lvItems.Items.Count)
        'il seg. ciclo riempie l'array items.Items con i percorsi degli item con l'aiuto della funzione joinItemName, che costruisce il nome "fully qualified" a partire da percorso e nome corto
        For x As Integer = 0 To GItemList1.lvItems.Items.Count - 1
            items.Items(x) = New ReadRequestItem
            items.Items(x).ItemName = joinItemName(GItemList1.lvItems.Items(x).SubItems(0).Text, GItemList1.lvItems.Items(x).SubItems(1).Text)
        Next x
        Try
            reply = Srv.Read(rOpt, items, ritems, errors)

            For Each err As OPCError In errors
                formMainI.addToLog(err.ID.Name + "    " + err.Text)
            Next

            'il seg. ciclo aggiorna la ListView in base al contenuto dei valori restituiti dal metodo Read, contenuti nell'array ritems.Items
            For x As Integer = 0 To GItemList1.lvItems.Items.Count - 1
                With GItemList1.lvItems.Items(x)
                    If Not IsNothing(ritems.Items(x).ResultID) Then .SubItems(5).Text = ritems.Items(x).ResultID.Name Else .SubItems(5).Text = ""
                    If Not ritems.Items(x).Value.GetType.IsArray Then .SubItems(2).Text = ritems.Items(x).Value
                    .SubItems(6).Text = isntNothing(ritems.Items(x).ValueTypeQualifier)
                    .SubItems(4).Text = isntNothing(ritems.Items(x).Timestamp)
                    If IsNothing(ritems.Items(x).Quality) Then
                        .SubItems(7).Text = ""
                        .SubItems(3).Text = ""
                        .SubItems(8).Text = ""
                    Else
                        .SubItems(7).Text = GItemList1.cbLimitField.Items(ritems.Items(x).Quality.LimitField)
                        .SubItems(3).Text = GItemList1.cbQualityField.Items(ritems.Items(x).Quality.QualityField)
                        .SubItems(8).Text = isntNothing(ritems.Items(x).Quality.VendorField)
                    End If
                End With
            Next x
        Catch err As Exception
            MsgBox(err.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub


    Private Sub txtMaxAge_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtMaxAge.LostFocus
        tb2Integer(txtMaxAge, "")
    End Sub

    Private Sub buttClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttClose.Click
        Close()
    End Sub


    Private Sub formRead_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        subWinColl.Remove(Me)
        formMainI.Activate()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If formMainI.WindowState = FormWindowState.Minimized Then
            formMainI.WindowState = FormWindowState.Normal
        Else
            formMainI.Activate()
        End If
    End Sub
End Class
