Public Class formWrite
    Inherits System.Windows.Forms.Form

#Region " Codice generato da Progettazione Windows Form "

    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'Form esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents buttClose As System.Windows.Forms.Button
    Friend WithEvents buttWrite As System.Windows.Forms.Button
    Friend WithEvents GItemList1 As opc_xml_da_client.gItemList
    Friend WithEvents Button1 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(formWrite))
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.Button1 = New System.Windows.Forms.Button
        Me.buttClose = New System.Windows.Forms.Button
        Me.buttWrite = New System.Windows.Forms.Button
        Me.GItemList1 = New opc_xml_da_client.gItemList
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.Button1)
        Me.Panel1.Controls.Add(Me.buttClose)
        Me.Panel1.Controls.Add(Me.buttWrite)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Top
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(688, 48)
        Me.Panel1.TabIndex = 3
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(120, 8)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(112, 32)
        Me.Button1.TabIndex = 2
        Me.Button1.Text = "&<<"
        '
        'buttClose
        '
        Me.buttClose.Location = New System.Drawing.Point(232, 8)
        Me.buttClose.Name = "buttClose"
        Me.buttClose.Size = New System.Drawing.Size(112, 32)
        Me.buttClose.TabIndex = 3
        Me.buttClose.Text = "Chiudi"
        '
        'buttWrite
        '
        Me.buttWrite.Location = New System.Drawing.Point(8, 8)
        Me.buttWrite.Name = "buttWrite"
        Me.buttWrite.Size = New System.Drawing.Size(112, 32)
        Me.buttWrite.TabIndex = 1
        Me.buttWrite.Text = "&Write"
        '
        'GItemList1
        '
        Me.GItemList1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.GItemList1.ItemsReadOnly = False
        Me.GItemList1.ListReadOnly = False
        Me.GItemList1.Location = New System.Drawing.Point(0, 48)
        Me.GItemList1.Name = "GItemList1"
        Me.GItemList1.Size = New System.Drawing.Size(688, 261)
        Me.GItemList1.SubscriptionList = False
        Me.GItemList1.TabIndex = 0
        Me.GItemList1.VeryReadOnly = False
        '
        'formWrite
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(688, 309)
        Me.Controls.Add(Me.GItemList1)
        Me.Controls.Add(Me.Panel1)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "formWrite"
        Me.Text = "Write list"
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub buttWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttWrite.Click
        If GItemList1.lvItems.Items.Count = 0 Then
            MsgBox("Deve essere presente almeno un elemento nella lista", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        Dim reply As New ReplyBase
        Dim rOpt As New RequestOptions
        Dim items As New WriteRequestItemList
        Dim ritems As ReplyItemList
        Dim errors As OPCError()

        ReDim items.Items(GItemList1.lvItems.Items.Count)

        Try
            Dim x As Integer
            For Each li As ListViewItem In GItemList1.lvItems.Items
                items.Items(x) = New ItemValue

                With items.Items(x)
                    .Value = li.SubItems(2).Text
                    If li.SubItems(6).Text <> "" Then .ValueTypeQualifier = New System.Xml.XmlQualifiedName(li.SubItems(6).Text)
                    .ItemName = joinItemName(li.SubItems(0).Text, li.SubItems(1).Text)
                    .Quality = New OPCQuality
                    copyIf2(.Quality.LimitField, GItemList1.cbLimitField.Items.IndexOf(li.SubItems(7).Text))
                    copyIf2(.Quality.QualityField, GItemList1.cbLimitField.Items.IndexOf(li.SubItems(3).Text))
                    copyIf(.Quality.VendorField, li.SubItems(8).Text)
                    copyIfcond(.Timestamp, li.SubItems(4).Text, .TimestampSpecified)
                End With
                x += 1
            Next li

            rOpt.ReturnErrorText = True
            'rOpt.ReturnItemTime = True
            rOpt.ClientRequestHandle = getClientHandle()
            rOpt.LocaleID = LocaleID
            reply = Srv.Write(rOpt, items, False, ritems, errors)

            For Each err As OPCError In errors
                formMainI.addToLog(err.ID.Name + "    " + err.Text)
            Next

            For x = 0 To ritems.Items.Length - 1
                If Not IsNothing(ritems.Items(x).ResultID) Then GItemList1.lvItems.Items(x).SubItems(5).Text = ritems.Items(x).ResultID.Name Else GItemList1.lvItems.Items(x).SubItems(5).Text = ""
            Next x

        Catch err As Exception
            MsgBox(err.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub formWrite_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        subWinColl.Remove(Me)
        formMainI.Activate()
    End Sub

    Private Sub buttClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttClose.Click
        Me.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If formMainI.WindowState = FormWindowState.Minimized Then
            formMainI.WindowState = FormWindowState.Normal
        Else
            formMainI.Activate()
        End If
    End Sub
End Class
